new file mode 100755
@@ -0,0 +1,53 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2021, Jeff Layton <jlayton@redhat.com>
+#
+# FS QA Test No. 639
+#
+# Open a file and write a little data to it. Unmount (to clean out the cache)
+# and then mount again. Then write some data to it beyond the EOF and ensure
+# the result is correct.
+#
+# Prompted by a bug in ceph_write_begin that was fixed by commit 827a746f405d.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+
+_cleanup()
+{
+ cd /
+ rm -f $testfile
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+_supported_fs generic
+_require_test
+
+rm -f $seqres.full
+
+testfile="$TEST_DIR/test_write_begin.$$"
+
+# write some data to file and fsync it out
+$XFS_IO_PROG -f -c "pwrite -q 0 32" $testfile
+
+# cycle the mount to clean out the pagecache
+_test_cycle_mount
+
+# now, write to the file (near the end)
+$XFS_IO_PROG -c "pwrite -q 32 32" $testfile
+
+# dump what we think is in there
+echo "The result should be 64 bytes filled with 0xcd:"
+hexdump -C $testfile
+
+status=0
+exit
new file mode 100644
@@ -0,0 +1,5 @@
+QA output created by 639
+The result should be 64 bytes filled with 0xcd:
+00000000 cd cd cd cd cd cd cd cd cd cd cd cd cd cd cd cd |................|
+*
+00000040
@@ -641,3 +641,4 @@
636 auto quick swap
637 auto quick dir
638 auto quick rw
+639 auto quick rw
We had a broken optimization in cephfs and netfs lib that could cause part of a page to be improperly zeroed-out when writing to an offset that was beyond the EOF but in an existing page. Add a simple test that would have caught this. Signed-off-by: Jeff Layton <jlayton@kernel.org> --- tests/generic/639 | 53 +++++++++++++++++++++++++++++++++++++++++++ tests/generic/639.out | 5 ++++ tests/generic/group | 1 + 3 files changed, 59 insertions(+) create mode 100755 tests/generic/639 create mode 100644 tests/generic/639.out The kernel patch for this finally got merged, so we can refer to it in the comments now. Also go ahead and set this test to be #639 instead of XXX.